import BundleRegistry from "./BundleRegistry";

export default function(bundleName) {
	const langMap = BundleRegistry.getBundle(bundleName) || {};
	var bundle = {};

	bundle.t = function(key) {
		var args = [key, key].concat(Array.prototype.slice.call(arguments).slice(1));
		return bundle.tFallback.apply(bundle, args);
	};

	bundle.tFallback = function(key, defaultValue) {
		var value = langMap[key];
		if (value !== undefined) {
			// replace all given options
			for (var i = 2; i < arguments.length; i++) {
				value = value.replace("{" + (i - 2) + "}", arguments[i]);
			}
			return value;
		} else {
			return defaultValue;
		}
	};

	bundle.asMap = function() {
		return langMap;
	};

	return bundle;
}
